#ifndef ACCOUNTS_H
#define ACCOUNTS_H

#include <sys/types.h>
#include <unistd.h>

#include <picogui.h>

#define SERIAL_DIRECT 0
#define SERIAL_MODEM  1
#define IRCOMM_DIRECT 2
#define IRCOMM_MODEM  3

typedef struct {
	char *section;

        pid_t pid;
	int pfd;
        int pfderr;
	pghandle handle;
} Account;

typedef struct {
	Account *accts;
	int n_accts;
} Account_list;

Account_list *al_load(void);
int al_new_acct(Account_list *al);
int al_delete_acct(Account_list *al, int i);
void acct_save(void);
const char *acct_name(Account_list *al, int i);
void acct_sethandle(Account_list *al, int i, pghandle h);
pghandle acct_gethandle(Account_list *al, int i);

int acct_start(Account_list *al, int i);
int acct_edit(Account_list *al, int i);
int acct_isconnected(Account_list *al, int i);
int acct_stop(Account_list *al, int i);

const char *acct_type(Account_list *al, int i);
const char *acct_fctrl(Account_list *al, int i);
const char *acct_dnstype(Account_list *al, int i);
const char *acct_device(Account_list *al, int i);
const char *acct_phone(Account_list *al, int i);
const char *acct_user(Account_list *al, int i);
const char *acct_pass(Account_list *al, int i);
const char *acct_speed(Account_list *al, int i);
int acct_defaultgw(Account_list *al, int i);
int acct_hcomp(Account_list *al, int i);

void acct_set_name(Account_list *al, int i, char *s);
void acct_set_type(Account_list *al, int i, char *s);
void acct_set_fctrl(Account_list *al, int i, char *s);
void acct_set_dnstype(Account_list *al, int i, char *s);
void acct_set_device(Account_list *al, int i, char *s);
void acct_set_phone(Account_list *al, int i, char *s);
void acct_set_user(Account_list *al, int i, char *s);
void acct_set_pass(Account_list *al, int i, char *s);
void acct_set_speed(Account_list *al, int i, char *s);
void acct_set_defaultgw(Account_list *al, int i, int val);
void acct_set_hcomp(Account_list *al, int i, int val);

void write_log(char *s);

#endif






