#include <picogui.h>
#include "accounts.h"

int bttnType (struct pgEvent *evt);
int bttnDnstype (struct pgEvent *evt);
int bttnFlowctrl (struct pgEvent *evt);

static pghandle wType, wDnstype, wFlowctrl;

int acct_edit(Account_list *al, int i)
{
	pghandle wScroll, wClose, wCancel, wTmp;
	pghandle wName, wDevice, wPhone, wGw;
	pghandle wHComp, wUser, wPass, wSpeed, wPhoneLabel;
	struct pgEvent *evt;
	int adding=0;

	if(i==-1) {
		i=al_new_acct(al);
		adding=1;
	}

	pgEnterContext();
	pgDialogBox("Edit account");

	wScroll= pgNewWidget(PG_WIDGET_SCROLL, 0, 0);
	wTmp = pgNewWidget(PG_WIDGET_BOX, 0, 0);
	pgSetWidget (0, PG_WP_SIDE, PG_S_ALL, 0);
	pgSetWidget (wScroll, PG_WP_BIND, wTmp, 0);

	wTmp = pgNewWidget(PG_WIDGET_BOX, PG_DERIVE_INSIDE, wTmp);
	pgNewWidget(PG_WIDGET_LABEL, PG_DERIVE_INSIDE, wTmp);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString("Name: "),
		    PG_WP_SIDE, PG_S_LEFT,
		    0);
	wName = pgNewWidget(PG_WIDGET_FIELD, 0, 0);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString(acct_name(al, i)),
		    0);

	wTmp = pgNewWidget(PG_WIDGET_BOX, PG_DERIVE_AFTER, wTmp);
	pgNewWidget(PG_WIDGET_LABEL, PG_DERIVE_INSIDE, wTmp);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString("Type: "),
		    PG_WP_SIDE, PG_S_LEFT,
		    0);
	wType = pgNewWidget(PG_WIDGET_BUTTON, 0, 0);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString(acct_type(al, i)),
		    0);

	wTmp = pgNewWidget(PG_WIDGET_BOX, PG_DERIVE_AFTER, wTmp);
	pgNewWidget(PG_WIDGET_LABEL, PG_DERIVE_INSIDE, wTmp);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString("Device: "),
		    PG_WP_SIDE, PG_S_LEFT,
		    0);
	wDevice = pgNewWidget(PG_WIDGET_FIELD, 0, 0);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString(acct_device(al, i)),
		    0);

	wTmp = pgNewWidget(PG_WIDGET_BOX, PG_DERIVE_AFTER, wTmp);
	wPhoneLabel = pgNewWidget(PG_WIDGET_LABEL, PG_DERIVE_INSIDE, wTmp);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString("Phone: "),
		    PG_WP_SIDE, PG_S_LEFT,
		    0);
	wPhone = pgNewWidget(PG_WIDGET_FIELD, 0, 0);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString(acct_phone(al, i)),
		    0);

	wTmp = wGw = pgNewWidget(PG_WIDGET_CHECKBOX, PG_DERIVE_AFTER, wTmp);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString("Default Gateway"),
		    PG_WP_ON, acct_defaultgw(al, i),
		    0);

	wTmp = pgNewWidget(PG_WIDGET_BOX, PG_DERIVE_AFTER, wTmp);
	pgNewWidget(PG_WIDGET_LABEL, PG_DERIVE_INSIDE, wTmp);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString("DNS: "),
		    PG_WP_SIDE, PG_S_LEFT,
		    0);
	wDnstype = pgNewWidget(PG_WIDGET_BUTTON, 0, 0);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString(acct_dnstype(al, i)),
		    0);

	wTmp = pgNewWidget(PG_WIDGET_BOX, PG_DERIVE_AFTER, wTmp);
	pgNewWidget(PG_WIDGET_LABEL, PG_DERIVE_INSIDE, wTmp);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString("Flow Control: "),
		    PG_WP_SIDE, PG_S_LEFT,
		    0);
	wFlowctrl = pgNewWidget(PG_WIDGET_BUTTON, 0, 0);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString(acct_fctrl(al, i)),
		    0);

	wTmp = wHComp = pgNewWidget(PG_WIDGET_CHECKBOX, PG_DERIVE_AFTER, wTmp);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString("Header Compression"),
		    PG_WP_ON, acct_hcomp(al, i),
		    0);

	wTmp = pgNewWidget(PG_WIDGET_BOX, PG_DERIVE_AFTER, wTmp);
	pgNewWidget(PG_WIDGET_LABEL, PG_DERIVE_INSIDE, wTmp);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString("Username: "),
		    PG_WP_SIDE, PG_S_LEFT,
		    0);
	wUser = pgNewWidget(PG_WIDGET_FIELD, 0, 0);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString(acct_user(al, i)),
		    0);

	wTmp = pgNewWidget(PG_WIDGET_BOX, PG_DERIVE_AFTER, wTmp);
	pgNewWidget(PG_WIDGET_LABEL, PG_DERIVE_INSIDE, wTmp);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString("Password: "),
		    PG_WP_SIDE, PG_S_LEFT,
		    0);
	wPass = pgNewWidget(PG_WIDGET_FIELD, 0, 0);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString(acct_pass(al, i)),
		    0);

	wTmp = pgNewWidget(PG_WIDGET_BOX, PG_DERIVE_AFTER, wTmp);
	pgNewWidget(PG_WIDGET_LABEL, PG_DERIVE_INSIDE, wTmp);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString("Speed: "),
		    PG_WP_SIDE, PG_S_LEFT,
		    0);
	wSpeed = pgNewWidget(PG_WIDGET_FIELD, 0, 0);
	pgSetWidget(0,
		    PG_WP_TEXT, pgNewString(acct_speed(al, i)),
		    0);

	pgNewWidget(PG_WIDGET_TOOLBAR, PG_DERIVE_AFTER, wTmp);
	wClose = pgNewWidget(PG_WIDGET_BUTTON, 0, 0);
	pgSetWidget(0, PG_WP_TEXT, pgNewString("Save"), 0);
	wCancel = pgNewWidget(PG_WIDGET_BUTTON, 0, 0);
	pgSetWidget(0, PG_WP_TEXT, pgNewString("Cancel"), 0);

	do {
		evt = pgGetEvent();
		wTmp = evt->from;
		if(wTmp == wType) bttnType(evt);
		else if(wTmp == wDnstype) bttnDnstype(evt);
		else if(wTmp == wFlowctrl) bttnFlowctrl(evt);
	} while(wTmp != wClose && wTmp != wCancel);

	if(evt->from == wClose) {
		char *s;
		int tmp;

		s = pgGetString(pgGetWidget(wName,PG_WP_TEXT));
		acct_set_name(al, i, s);
		s = pgGetString(pgGetWidget(wDevice,PG_WP_TEXT));
		acct_set_device(al, i, s);
		s = pgGetString(pgGetWidget(wPhone,PG_WP_TEXT));
		acct_set_phone(al, i, s);
		s = pgGetString(pgGetWidget(wUser,PG_WP_TEXT));
		acct_set_user(al, i, s);
		s = pgGetString(pgGetWidget(wPass,PG_WP_TEXT));
		acct_set_pass(al, i, s);
		s = pgGetString(pgGetWidget(wSpeed,PG_WP_TEXT));
		acct_set_speed(al, i, s);
		s = pgGetString(pgGetWidget(wType,PG_WP_TEXT));
		acct_set_type(al, i, s);
		s = pgGetString(pgGetWidget(wDnstype,PG_WP_TEXT));
		acct_set_dnstype(al, i, s);
		s = pgGetString(pgGetWidget(wFlowctrl,PG_WP_TEXT));
		acct_set_fctrl(al, i, s);

		tmp = pgGetWidget(wGw, PG_WP_ON);
		acct_set_defaultgw(al, i, tmp);
		tmp = pgGetWidget(wHComp, PG_WP_ON);
		acct_set_hcomp(al, i, tmp);

		acct_save();
	} else if(adding) {
		al_delete_acct(al, i);
	}

	pgLeaveContext();
	return 0;
}

int bttnType (struct pgEvent *evt)
{
	switch(pgMenuFromString("DIRECT|MODEM")) {
	case 1:
		pgReplaceText(wType, "DIRECT");
		break;
	case 2:
		pgReplaceText(wType, "MODEM");
		break;
	}
	return 0;
}

int bttnDnstype (struct pgEvent *evt)
{
	switch(pgMenuFromString("NONE|DYNAMIC")) {
	case 1:
		pgReplaceText(wDnstype, "NONE");
		break;
	case 2:
		pgReplaceText(wDnstype, "DYNAMIC");
		break;
	}
	return 0;
}

int bttnFlowctrl (struct pgEvent *evt)
{
	switch(pgMenuFromString("CRTSCTS|CDTRCTS|XONXOFF|NONE")) {
	case 1:
		pgReplaceText(wFlowctrl, "CRTSCTS");
		break;
	case 2:
		pgReplaceText(wFlowctrl, "CDTRCTS");
		break;
	case 3:
		pgReplaceText(wFlowctrl, "XONXOFF");
		break;
	case 4:
		pgReplaceText(wFlowctrl, "NONE");
		break;
	}
	return 0;
}
